//+------------------------------------------------------------------+
//|                                               TerminalOrders.mq4 |
//|                        Copyright  2011, NQueiros Software Corp. |
//|                                   Email:nqueirosmail@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, NQueiros Software Corp."
#property link      "Email:nqueirosmail@hotmail.com"
#property library
#import "InitializeStringArray2D.ex4" int InitializeStringArray2D(string &Array[][],string Word,int DS0S,int DS0E,int DS1S,int DS1E);
#import "FindDoubleInString.ex4" bool FindDoubleInString(string Words,double Search,string SS);
#import "OrderTypeInString.ex4" string OrderTypeInString(int Ticket);
// This Function is to Count Orders in The Terminal and Store The Orders Found With his Parameters in a String Array2D
// This Function Return The Number of Orders Processed/Found
// MODE_TRADES_AUTO = Works as the "MODE_TRADES", but Tickets Are Constant Memorized as Well his Respective Indexs Containing Parameters,
//                    Memorized Tickets Are Analised and if doesn't Exists in the Trading Pool,the ticket memorized in the Array is Deleted With All his Indexs.
// MODE_TRADES = Read All Parameters of order selected from trading pool(opened and pending orders).Array is Initialized At Each Call of This Function.
// MODE_HISTORY = Read All Parameters of order selected from history pool (closed and canceled order).Array is Initialized At Each Call of This Function.
// MODE_DELETE = Initialize All Indexs Where Selected Ticket Is.
// Revised/Version 22/02/2012

int TerminalOrders(string &A[][],                  //0- Array to Store the Orders Found
                   string S="",                    //1- Symbol(If Null/Empty Count All Orders)
                   int    Magic=0,                 //2- Magic Number(if<=0 Process All, if >0 Process Only by Magic)
                   string Mode="MODE_TRADES_AUTO", //3- Mode Select
                   string SI="",                   //4- String Imput(MODE_TRADES_AUTO=Indexs to Ignore in Array/MODE_DELETE=Tickets to Delete from Array)
                   string SS=",",                  //5- Separator Symbol
                   bool   AutoSize=false)          //6- Sets Array Size Basead in Number of Avaiable Orders in The Terminal
  {
   // Prevent Bugs/Errors
   if(Magic<0)return(0);            // If No Exists Magic
   if(ArrayRange(A,1)<17)return(0); // If Array has Less Than Minimum(17 Indexs) to Store All Parameters of Ticket
   if(S=="NULL")S="";               // Change to Empty
   
   bool Resize=false; // Resize Array
   int Total=0;       // Total of Orders Processed
   
   if(ArrayRange(A,0)<=0 || AutoSize)Resize=true; // Resize Array
   
   //---- MODE_AUTO --------------------------------------------------------------------------
   if(Mode=="MODE_TRADES_AUTO")
     {
      if(ArrayRange(A,0)<=0)return(0); // if Array has no Indexs
      
      // Compare Tickets in Array to Terminal Tickets
      // Delete from array those that doesn't exist
      // Actualize those that Exists
      Total=TOArrayProcess(A,   //0- Array to Process
                           SI,  //1- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
                           SS); //2- Separator Symbol
      
      // Compare Tickets in the Terminal with Array
      // if Found Ticket in The Array, do Nothing
      // If Not Found, Store the Ticket With All his parameters to the First Empty Index                    
      Total+=TOProcess(A,     //0- Array to Process
                       S,     //1- Symbol(If EMPTY Count All Orders)
                       Magic, //2- Magic Number(if==0 Process All, if !=0 Process Only by Magic)
                       SI,    //3- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
                       SS);   //4- Separator Symbol
     }
   //---- MODE_TRADES --------------------------------------------------------------------------
   if(Mode=="MODE_TRADES")
     {
      // Store all Tickts of Terminal to Array
      Total=TO_MODE_TRADES(A,      //0- Array to Process
                           S,      //1- Symbol(If EMPTY Count All Orders)
                           Magic,  //2- Magic Number(if<=0 Process All, if >0 Process Only by Magic)
                           Resize, //3- Resize Array
                           SI,     //4- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
                           SS);    //5- Separator Symbol
     }
   //---- MODE_HISTORY --------------------------------------------------------------------------
   if(Mode=="MODE_HISTORY")
     {
      // Store all Tickts of History Terminal to Array
      Total=TO_MODE_HISTORY(A,      //0- Array to Process
                            S,      //1- Symbol(If EMPTY Count All Orders)
                            Magic,  //2- Magic Number(if<=0 Process All, if >0 Process Only by Magic)
                            Resize, //3- Resize Array
                            SI,     //4- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
                            SS);    //5- Separator Symbol
     }      
   //---- MODE_DELETE --------------------------------------------------------------------------
   if(Mode=="MODE_DELETE")
     {
      // Delete Selected Tickets
      Total=TO_MODE_DELETE(A,   //0- Array to Process
                           SI,  //1- Ticket Delete (Ticket Numbers to be Deleted from Array)
                           SS); //2- Separator Symbol to Delete String
     }     
   return(Total);// Return Number of Orders Processed
  }

//---------------------------------------+   
//  0- MODE_TRADES_AUTO(ARRAY PROCESS)   +
//---------------------------------------+

// Compare Tickets in Array to Terminal Tickets
// Delete from array those that doesn't exist
// Actualize those that Exists
int TOArrayProcess(string &A[][], //0- Array to Process
                   string II="",  //1- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
                   string SS=",") //2- Separator Symbol
  {
   int Total=0; // Cnt Total Orders Processed
   
   // Loop to Pass All Indexs [x][] in Array
   for(int cnt0=0;cnt0<ArrayRange(A,0);cnt0++)
      {
       // If Exists Ticket Number
       if(StrToInteger(A[cnt0][0])>0)
         {
          int Ticket=StrToInteger(A[cnt0][0]);
          bool Reset=true;
          
          // Search for Ticket in Trading Terminal
          if(OrderSelect(Ticket,SELECT_BY_TICKET) && // Order Selected == True
             OrderCloseTime()<=0)                    // Order is open or pending and taken from the terminal open positions list
            {                
             // Refresh Order Parameters 
             if(!FindDoubleInString(II,1,SS))A[cnt0][1]=OrderSymbol();
             if(!FindDoubleInString(II,2,SS))A[cnt0][2]=OrderTypeInString(OrderTicket());
             if(!FindDoubleInString(II,3,SS))A[cnt0][3]=DoubleToStr(OrderLots(),2);
             if(!FindDoubleInString(II,4,SS))A[cnt0][4]=DoubleToStr(OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
             if(!FindDoubleInString(II,5,SS))A[cnt0][5]=DoubleToStr(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));
             if(!FindDoubleInString(II,6,SS))A[cnt0][6]=DoubleToStr(OrderTakeProfit(),MarketInfo(OrderSymbol(),MODE_DIGITS));
             if(!FindDoubleInString(II,7,SS))A[cnt0][7]=OrderComment();
             if(!FindDoubleInString(II,8,SS))A[cnt0][8]=OrderMagicNumber();
             if(!FindDoubleInString(II,9,SS))A[cnt0][9]=OrderExpiration();
             if(!FindDoubleInString(II,10,SS))A[cnt0][10]=OrderOpenTime();
             if(!FindDoubleInString(II,11,SS))A[cnt0][11]=DoubleToStr(OrderProfit()+OrderSwap()+OrderCommission(),2);// Calculeted Real Profit
             if(!FindDoubleInString(II,12,SS))A[cnt0][12]=DoubleToStr(OrderProfit(),2);
             if(!FindDoubleInString(II,13,SS))A[cnt0][13]=DoubleToStr(OrderClosePrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
             if(!FindDoubleInString(II,14,SS))A[cnt0][14]=OrderCloseTime();
             if(!FindDoubleInString(II,15,SS))A[cnt0][15]=DoubleToStr(OrderCommission(),2);
             if(!FindDoubleInString(II,16,SS))A[cnt0][16]=DoubleToStr(OrderSwap(),2);
                
             Total++;     // Cnt Number of Array Indexs Not found in The Terminal
             Reset=false; // Sets Reset to False
            }
          if(Reset)InitializeStringArray2D(A,0,cnt0,cnt0,0,-1); // Initialize Array in Selected [x][]
         }// End of if Exists Ticket
      }// End of Loop 0
   return(Total);
  }

//-------------------------------------------------+   
//  1- MODE_TRADES_AUTO(TERMINAL ORDERS PROCESS)   +
//-------------------------------------------------+

// Compare Tickets in the Terminal with Array
// if Found Ticket in The Array, do Nothing
// If Not Found, Store the Ticket With All his parameters to the First Empty Index
int TOProcess(string &A[][],   //0- Array to Process
              string S="",     //1- Symbol(If EMPTY Count All Orders)
              int    Magic=0,  //2- Magic Number(if<=0 Process All, if >0 Process Only by Magic)
              string II="",    //3- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
              string SS=",")   //4- Separator Symbol
  {
   int Total=0; // Cnt Total Orders Processed
   
   //--- LOOP TO PASS ALL ORDERS IN THE TERMINAL ----------------------------------------------------------------------------------------
   for(int cnt0=0;cnt0<OrdersTotal();cnt0++) // For Market/Pending orders
      {
       if(OrderSelect(cnt0,SELECT_BY_POS,MODE_TRADES) &&          // Order Selected == True
          ((Magic>0 && OrderMagicNumber()==Magic) || Magic<=0) && // Magic is Selected && MagicNumber == Extern Magic || Magic not defined
          ((S!="" && OrderSymbol()==S) || S==""))                 // Symbol is Selected && Symbol == Extern Symbol || Symbol not Defined
         {
          bool Store=true;
          
          //--- Loop to Pass All Indexs [x][] in Array and search if Ticket Exists in the terminal --------
          for(int cnt1=0;cnt1<ArrayRange(A,0);cnt1++)
             {
              if(StrToInteger(A[cnt1][0])==OrderTicket())
                {
                 Store=false; // Sets Store to false
                 break;       // Break Loop 1
                }
             }
          
          //--- if Terminal Ticket Don't Exists in the Array, Store it --------------------------------------
          if(Store)
            {
             // Loop to Pass All Indexs [x][] in Array
             for(int cnt2=0;cnt2<ArrayRange(A,0);cnt2++)
                {
                 // If NO Exists Ticket Number
                 if(StrToInteger(A[cnt2][0])<=0)
                   {
                    // Store Order Parameters 
                    if(!FindDoubleInString(II,0,SS))A[cnt2][0]=OrderTicket();
                    if(!FindDoubleInString(II,1,SS))A[cnt2][1]=OrderSymbol();
                    if(!FindDoubleInString(II,2,SS))A[cnt2][2]=OrderTypeInString(OrderTicket());
                    if(!FindDoubleInString(II,3,SS))A[cnt2][3]=DoubleToStr(OrderLots(),2);
                    if(!FindDoubleInString(II,4,SS))A[cnt2][4]=DoubleToStr(OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
                    if(!FindDoubleInString(II,5,SS))A[cnt2][5]=DoubleToStr(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));
                    if(!FindDoubleInString(II,6,SS))A[cnt2][6]=DoubleToStr(OrderTakeProfit(),MarketInfo(OrderSymbol(),MODE_DIGITS));
                    if(!FindDoubleInString(II,7,SS))A[cnt2][7]=OrderComment();
                    if(!FindDoubleInString(II,8,SS))A[cnt2][8]=OrderMagicNumber();
                    if(!FindDoubleInString(II,9,SS))A[cnt2][9]=OrderExpiration();
                    if(!FindDoubleInString(II,10,SS))A[cnt2][10]=OrderOpenTime();
                    if(!FindDoubleInString(II,11,SS))A[cnt2][11]=DoubleToStr(OrderProfit()+OrderSwap()+OrderCommission(),2);// Calculeted Real Profit
                    if(!FindDoubleInString(II,12,SS))A[cnt2][12]=DoubleToStr(OrderProfit(),2);
                    if(!FindDoubleInString(II,13,SS))A[cnt2][13]=DoubleToStr(OrderClosePrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
                    if(!FindDoubleInString(II,14,SS))A[cnt2][14]=OrderCloseTime();
                    if(!FindDoubleInString(II,15,SS))A[cnt2][15]=DoubleToStr(OrderCommission(),2);
                    if(!FindDoubleInString(II,16,SS))A[cnt2][16]=DoubleToStr(OrderSwap(),2);
                     
                    Total++;// Cnt Total parameters Processed
                    break;  // Break Loop 2
                   }
                }// End of Loop cnt1
            }
         }// End of Loop cnt0
      } 
   return(Total);
  }

//-------------------+   
//  2- MODE_TRADES   +
//-------------------+
int TO_MODE_TRADES(string &A[][],       //0- Array to Process
                   string S="",         //1- Symbol(If EMPTY Count All Orders)
                   int    Magic=0,      //2- Magic Number(if<=0 Process All, if >0 Process Only by Magic)
                   bool   Resize=false, //3- Resize Array
                   string II="",        //4- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
                   string SS=",")       //5- Separator Symbol
  {
   int Total=0; // Cnt Total Orders Processed
   int cnt1=0;  // Array Cnt
   if(ArrayRange(A,0)>0)InitializeStringArray2D(A,0,0,-1,0,-1); // Initialize Array To Store Values
   
   // Loop To Pass All Orders in the Terminal
   for(int cnt0=0;cnt0<OrdersTotal();cnt0++) // For Market/Pending orders
      {
       if(OrderSelect(cnt0,SELECT_BY_POS,MODE_TRADES) &&          // Order Selected == True
          ((Magic>0 && OrderMagicNumber()==Magic) || Magic<=0) && // Magic is Selected && MagicNumber == Extern Magic || Magic not defined
          ((S!="" && OrderSymbol()==S) || S==""))                 // Symbol is Selected && Symbol == Extern Symbol || Symbol not Defined
         {
          Total++;                        // Set next Index/Cnt Total parameters Processed
          if(Resize)ArrayResize(A,Total); // Set Array Size For Store Next parameters
          
          // Store Order Parameters 
          if(!FindDoubleInString(II,0,SS))A[cnt1][0]=OrderTicket();
          if(!FindDoubleInString(II,1,SS))A[cnt1][1]=OrderSymbol();
          if(!FindDoubleInString(II,2,SS))A[cnt1][2]=OrderTypeInString(OrderTicket());
          if(!FindDoubleInString(II,3,SS))A[cnt1][3]=DoubleToStr(OrderLots(),2);
          if(!FindDoubleInString(II,4,SS))A[cnt1][4]=DoubleToStr(OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,5,SS))A[cnt1][5]=DoubleToStr(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,6,SS))A[cnt1][6]=DoubleToStr(OrderTakeProfit(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,7,SS))A[cnt1][7]=OrderComment();
          if(!FindDoubleInString(II,8,SS))A[cnt1][8]=OrderMagicNumber();
          if(!FindDoubleInString(II,9,SS))A[cnt1][9]=OrderExpiration();
          if(!FindDoubleInString(II,10,SS))A[cnt1][10]=OrderOpenTime();
          if(!FindDoubleInString(II,11,SS))A[cnt1][11]=DoubleToStr(OrderProfit()+OrderSwap()+OrderCommission(),2);// Calculeted Real Profit
          if(!FindDoubleInString(II,12,SS))A[cnt1][12]=DoubleToStr(OrderProfit(),2);
          if(!FindDoubleInString(II,13,SS))A[cnt1][13]=DoubleToStr(OrderClosePrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,14,SS))A[cnt1][14]=OrderCloseTime();
          if(!FindDoubleInString(II,15,SS))A[cnt1][15]=DoubleToStr(OrderCommission(),2);
          if(!FindDoubleInString(II,16,SS))A[cnt1][16]=DoubleToStr(OrderSwap(),2);
          cnt1++;// Set next Position in the Array
          
          // if Total Tickets Memorized >= Last Array Index
          if(!Resize && Total>=ArrayRange(A,0))return(Total);
         }
      }
   return(Total);
  }
  
//--------------------+   
//  3- MODE_HISTORY   +
//--------------------+
int TO_MODE_HISTORY(string &A[][],       //0- Array to Process
                    string S="",         //1- Symbol(If EMPTY Count All Orders)
                    int    Magic=0,      //2- Magic Number(if<=0 Process All, if >0 Process Only by Magic)
                    bool   Resize=false, //3- Resize Array
                    string II="",        //4- Indexs to Ignore(Don't Get Values of terminal In case of Hide TP/SL or Others Values)
                    string SS=",")       //5- Separator Symbol
  {
   int Total=0; // Cnt Total Orders Processed
   int cnt1=0;  // Array Cnt
   if(ArrayRange(A,0)>0)InitializeStringArray2D(A,0,0,-1,0,-1); // Initialize Array To Store Values
   
   // Loop To Pass All Orders in the Terminal
   for(int cnt0=0;cnt0<OrdersHistoryTotal();cnt0++) // For Closed/History orders
      {
       if(OrderSelect(cnt0,SELECT_BY_POS,MODE_HISTORY) &&         // Order Selected == True
          ((Magic>0 && OrderMagicNumber()==Magic) || Magic<=0) && // Magic is Selected && MagicNumber == Extern Magic || Magic not defined
          ((S!="" && OrderSymbol()==S) || S==""))                 // Symbol is Selected && Symbol == Extern Symbol || Symbol not Defined
         {
          Total++;                        // Set next Index/Cnt Total parameters Processed
          if(Resize)ArrayResize(A,Total); // Set Array Size For Store Next parameters
          
          // Store Order Parameters 
          if(!FindDoubleInString(II,0,SS))A[cnt1][0]=OrderTicket();
          if(!FindDoubleInString(II,1,SS))A[cnt1][1]=OrderSymbol();
          if(!FindDoubleInString(II,2,SS))A[cnt1][2]=OrderTypeInString(OrderTicket());
          if(!FindDoubleInString(II,3,SS))A[cnt1][3]=DoubleToStr(OrderLots(),2);
          if(!FindDoubleInString(II,4,SS))A[cnt1][4]=DoubleToStr(OrderOpenPrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,5,SS))A[cnt1][5]=DoubleToStr(OrderStopLoss(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,6,SS))A[cnt1][6]=DoubleToStr(OrderTakeProfit(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,7,SS))A[cnt1][7]=OrderComment();
          if(!FindDoubleInString(II,8,SS))A[cnt1][8]=OrderMagicNumber();
          if(!FindDoubleInString(II,9,SS))A[cnt1][9]=OrderExpiration();
          if(!FindDoubleInString(II,10,SS))A[cnt1][10]=OrderOpenTime();
          if(!FindDoubleInString(II,11,SS))A[cnt1][11]=DoubleToStr(OrderProfit()+OrderSwap()+OrderCommission(),2);// Calculeted Real Profit
          if(!FindDoubleInString(II,12,SS))A[cnt1][12]=DoubleToStr(OrderProfit(),2);
          if(!FindDoubleInString(II,13,SS))A[cnt1][13]=DoubleToStr(OrderClosePrice(),MarketInfo(OrderSymbol(),MODE_DIGITS));
          if(!FindDoubleInString(II,14,SS))A[cnt1][14]=OrderCloseTime();
          if(!FindDoubleInString(II,15,SS))A[cnt1][15]=DoubleToStr(OrderCommission(),2);
          if(!FindDoubleInString(II,16,SS))A[cnt1][16]=DoubleToStr(OrderSwap(),2);
          cnt1++;// Set Next Position in the Array
          
          // if Total Tickets Memorized >= Last Array Index
          if(!Resize && Total>=ArrayRange(A,0))return(Total);
         }
      }
   return(Total);
  }
   
//-------------------+   
//  4- MODE_DELETE   +
//-------------------+
int TO_MODE_DELETE(string &A[][], //0- Array to Process
                   string TK="0", //1- Tickets to Delete (Tickets Numbers to be Deleted from Array)
                   string SS=",") //2- Separator Symbol to Delete String
  {
   int Total=0;// Cnt number of Tickets Found and Reseted
   
   // Loop To Pass All Indexes [x][] in Array
   for(int cnt0=0;cnt0<ArrayRange(A,0);cnt0++)
         {
          if(FindDoubleInString(TK,A[cnt0][0],SS))// if Found Ticket in Array
            {
             InitializeStringArray2D(A,0,cnt0,cnt0,0,-1);// Reset Array index Containing the Ticket Number
             Total++;// Cnt number of Tickets Found and Reseted
            }
         }
   return(Total);
  }